from visual import *
from visual.graph import *
from PIL import ImageGrab

scene.title="Dynamic Equilibrium Simulation"
scene.range = 10

#demensions
rope_length = 5
spring_length = 2
spring_start = 2
size = 0.75
#constants
g = 9.8
k = 1
m = 1
dt = 0.001

time = 10

pulley = cylinder(pos=(0,0,-0.25), axis=(0,0,0.5), radius=1)
left_string = cylinder(pos=(-1,0,0), axis=(0,-rope_length,0), radius=0.05)
right_string = cylinder(pos=(1,0,), axis=(0,-rope_length,0), radius=0.05)

box_a = box(pos = left_string.pos + left_string.axis, 
            length = size, width = size, height = size*2, color = color.blue)
box_b= box(pos = right_string.pos + right_string.axis,                            
            length = size, width = size, height = size, color = color.red)


t = 0
box_a.vel = 0.0
box_b.vel = 0.0

Fs = 0.0
T = 0.0

gdisplay(title='Velocity', xtitle='Time', ytitle='Velocity',
        xmax=5.0, ymax=5, ymin=-10, x=0, y=450, width=500, height=300)


vel_a = gcurve(color=color.blue)
pos_a = gdots(color=color.blue, size = 5)
vel_b = gcurve(color=color.red)
pos_b = gdots(color=color.red, size = 5)

while t < time:
    rate(800)
    T = (4.0/3.0) * g
    
    im = ImageGrab.grab((40,50,500,820))
    im.save('blocks/img-' + str(int(t/dt)) +'.png')

    box_a.vel += dt * (T/2.0 - g)
    box_b.vel += dt * (T - g)
    

    box_a.pos.y += dt * box_a.vel
    box_b.pos.y += dt * box_b.vel
    
    left_string.axis.y = box_a.pos.y
    right_string.axis.y = box_b.pos.y
    
    vel_a.plot(pos=(t, box_a.vel))
    pos_a.plot(pos=(t, box_a.y))
    vel_b.plot(pos=(t, box_b.vel))
    pos_b.plot(pos=(t, box_b.y))
    
    if(box_a.pos.y > 0 or box_b.pos.y > 0):
        break
    t += dt
